/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#include "../Framework3/OpenGL/OpenGLApp.h"
#include "../Framework3/Math/Noise.h"

class App : public OpenGLApp {
public:
	char *getTitle() const { return "Domino"; }

	void resetCamera();

	bool onKey(const uint key, const bool pressed);
	void controls();

	bool init();
	void exit();

	bool load();
	void unload();

	void drawFrame();

protected:
	bool findCollision(const vec2 &pos);
	void arrangeTiles();

	vec2 attractionPoint;
	uint attractionTile;

	ShaderID tileShader, floorShader;
	TextureID floorBase, floorBump, noise;
	SamplerStateID trilinear, trilinearAniso;

	VertexFormatID tileVF;
	VertexBufferID tileVB;

	Array <vec4> tiles;

	float fade;

	CheckBox *freeFly;
};
